import * as ec2 from "aws-cdk-lib/aws-ec2";
import * as events from "aws-cdk-lib/aws-events";
import * as rds from "aws-cdk-lib/aws-rds";
import { Construct } from "constructs";
type DbEngine = "mysql";
export interface RdsDumpProps {
    readonly dbEngine: DbEngine;
    readonly rdsCluster: rds.DatabaseCluster;
    readonly schedule: events.Schedule;
    readonly databaseName: string;
    readonly idSuffix?: string;
    readonly lambdaNsg?: ec2.ISecurityGroup[];
    readonly lambdaEnv?: {
        [key: string]: string;
    };
    readonly unsecureUserName?: string;
    readonly unsecurePassword?: string;
    readonly secretId?: string;
    readonly createSecretsManagerVPCEndpoint: boolean;
    readonly secretsManagerVPCEndpointNsgId?: string;
}
export declare class RdsDump extends Construct {
    constructor(scope: Construct, id: string, { dbEngine, rdsCluster, databaseName, idSuffix, schedule, lambdaNsg, lambdaEnv, unsecureUserName, unsecurePassword, secretId, createSecretsManagerVPCEndpoint, secretsManagerVPCEndpointNsgId, }: RdsDumpProps);
}
export {};
